structure dut = struct
local
  open SmlMC_head
in
val with_timing = false
val model_check = true

val (think,has_left,eat)=(1,2,3)
val (on_table,used)=(0,1)

val components =
#[ ref(#[think,think,think]),         (* philosophers *)
   ref(#[on_table,on_table,on_table]) (* forks *)
]

val \ = fn(a,c) => Vector.sub(a,c)
infix 9 \

val phs = components\0
val frks = components\1
fun set_ph(n,ph) = phs := Vector.tabulate(3,fn m => if n=m then ph else (!phs)\m)
fun set_frk(n,frk) = frks := Vector.tabulate(3,fn m => if n=m then frk else (!frks)\m)

val evs = #[nop(),nop(),nop()]

fun ph_func(id,lfork,rfork)(e_l,e_r) = fn() =>
  let
    val (ph,l,r) =
      let
        val phil = (!phs)\id
        val lfork = (!frks)\lfork
        val rfork = (!frks)\rfork
        val param = (phil,lfork,rfork)
      in
        if phil=think then
          if lfork=on_table then (has_left,used,rfork)
          else param
        else if phil=has_left andalso rfork=on_table then (eat,used,used)
        else if phil=eat then (think,on_table,on_table)
        else param
      end
  in
    set_ph(id,ph); set_frk(lfork,l); set_frk(rfork,r);
    act (evs\e_l); act (evs\e_r)
  end

val events = init_ev
[ ev (evs\0) (ph_func(0,0,1)(2,1)),
  ev (evs\1) (ph_func(1,1,2)(0,2)),
  ev (evs\2) (ph_func(2,2,0)(0,1))
]

val _ = (
(* ---- preventing deadlock ----
   path_test :=
   ( fn () => if !phs = #[has_left,has_left,has_left]
     then (set_ph(0,think); set_frk(0,on_table))
     else ()
   );
  ------------------------------ *)
  act(evs\0); act(evs\1); act(evs\2)
)

val print_comp = fn v => pr.printq `[^(pr.vec v pr.d)] `

end
end
