structure Misc2 = struct
local open TextIO
in

fun say s =
( print "say: "; print(s ^ "\n") before (flushOut stdOut)
)

fun incr s = s := (!s)+1
fun decr s = s := (!s)-1

fun push x s = s := x :: !s

fun pop s =
  case !s of
    h::t => (s := t; h)
  | []     => raise Fail "stack empty"

fun iter f s = List.app f (!s)

fun on_stack p oper s =
  let 
  val rec f = fn
    [] => false
  | (x::xs) => if oper(p,x) then true else (f xs)
  in
    f (!s)
  end

fun for(a,b,f) = if a>b then () else (f(a); for(a+1,b,f))

end
end
